   1 REM Girl Genius? en/decoder
      by Jim Grimwood 2001      
         jg27paw4@globalnet.co.uk
   2 REM Find Girl Genius at    
     http://www.girlgenius.ws/
   3 REM Command UDGs:-         
   A=?=Blue (inner) ring        
   B=?=Yellow (middle) ring     
   C=?=Red (outer) ring         
   D=?=Set Code ring            
   E=?=Set Target ring          
   F=?=Spin clockwise           
   G=?=Spin anti-clockwise      
   H=?=Ignore/Resume
   4 REM Other UDGs:-           
   T=?=Trademark symbol
   5 DEF FN f(f$)=CODE f$-codeA+1:DEF FN f$(f)=CHR$ (f-1+codeA):
     DEF FN i(r)=7-(2 AND r=1)-(1 AND r=2)-(5 AND r=3):DEF FN n(
     n)=1+INT (RND*n)
  10 LOAD "Genius_UDG"CODE PEEK 23675+256*PEEK 23676,168
  20 PAPER 0:INK 7:BORDER 0:CLS:LET codeA=CODE "?":REM UDG "A"
  30 DIM k$(5):DIM r$(44):DIM w$(3,44):LET ignore=0:POKE 23658,8
  31 LET w$(1)="?9GUPK?J4VHYQ6??ZE3?A2D?CTL1ISX?R5MN?FW0B7O8"
  32 LET w$(2)="?0QGJ7V?4USPYBL?Z?3OEIF2?TDAX?1NCM5R6K8??WH9"
  33 LET w$(3)="?ERHGTCWYXK?OQ4MJ?6A?FDB3?I278L1?5V?9PS?Z0UN"
  34 PRINT "Command UDGs:"'BRIGHT 1;INK 5;"?";INK 7;"=A,";INK 6;
     "?";INK 7;"=B,";INK 2;"?";INK 7;"=C,?=D,?=E,?=F,?=G,?=H"
  35 INPUT "Encode/Decode?[ED]";o$:GO TO 35+(2005 AND o$="E")+(5
      AND o$="D")
  40 REM Start of Decode routine
  41 INPUT "Message Key>";k$''"Encoded Message>";e$
  42 REM LET k$="?9M??":LET e$="
U6C? A U6J? A??I6UU6? U3ALP6? 6C
86E ABA3NA UAKU ?6 UGI6 3Q ?I?CX
 Q8AJ3?C6 EJQP6 3Q U3G??Q ?QBJ?Q
 HD S?W N SW99 I?W2WPI9. ?SS9W A
??U ?H0PL ?NH?NW7 R ????."
  43 REM LET k$="GG1??":LET e$="
G3 C3 BBBT3C 0WE Q1YI?2C2KZ?2I21
M2N L?28I? ??L/QDMFD1Q/CD?URI21?
1NZ"
  45 PRINT "Key = ";k$''"Encoded Message ="''e$'':GO SUB 4000
 300 REM Main decoding loop
 301 PRINT '"Decoding ..."':LET d$=""
 310 FOR e=1 TO LEN e$
 320 LET c$=e$(e):PRINT c$,:IF c$>="0" AND c$<="9" OR c$>="A"
      AND c$<="Z" OR c$>="?" AND c$<="?" THEN 
       GO TO 330
 321 REM Characters not on the  
         wheel are not encoded
 322 IF  NOT ignore THEN 
       LET d$=d$+c$
 324 PRINT c$:POKE 23692,255:GO TO 590
 330 REM Process an encoded     
         character
 332 GO SUB 1300:LET b$=a$:PRINT b$;" ";
 340 IF b$="?" THEN 
       LET ignore= NOT ignore:PRINT "Ignore" AND ignore;"Resume"
        AND  NOT ignore:GO TO 590
 346 IF ignore THEN 
       PRINT "ignoring...":GO TO 590
 350 IF b$<"?" THEN 
       LET d$=d$+b$:PRINT :GO TO 590
 352 REM Not a regular character
       - process a command UDG
 355 LET e=e+1:LET c$=e$(e):GO SUB 1300
 359 REM Change Code Ring
 360 IF b$="?" THEN 
       GO SUB 1100:LET codeRing=k:GO TO 590
 369 REM Change Target Ring
 370 IF b$="?" THEN 
       GO SUB 1100:LET targRing=k:GO TO 590
 379 REM Spin clockwise
 380 IF b$="?" THEN 
       LET dir=+1:GO SUB 900:GO TO 590
 389 REM Spin anti-clockwise
 390 IF b$="?" THEN 
       LET dir=-1:GO SUB 900
 590 NEXT e
 600 PRINT '"Decoded Message ="''d$
 690 STOP
 900 REM Evaluate a spin command
 910 LET k=FN f(a$):GO SUB 1170:PRINT "spin ";INK FN i(k);a$;:
     LET e=e+1:LET c$=e$(e):GO SUB 1300:PRINT " ";"+" AND b$="?"
     ;"-" AND b$="?";a$:IF a$<"1" OR a$>"9" THEN 
       PRINT INK 2;FLASH 1;"INVALID SPIN":STOP
 930 LET c=VAL a$*dir
1000 REM Spin ring k, clockwise 
c clicks, or 44-c anti-clockwise
Setup   spin range = 1 to 43;   
Command spin range = 1 to 9
1010 IF c<-43 OR c>43 THEN 
       PRINT INK 2;FLASH 1'"INVALID SPIN '";c;"'":STOP
1011 IF c=0 THEN 
       RETURN
1020 IF c<0 THEN 
       LET c=44+c
1030 LET r$=w$(k,c+1 TO 44):LET w$(k,45-c TO )=w$(k,1 TO c):LET 
     w$(k,1 TO 44-c)=r$(1 TO 44-c)
1090 RETURN
1100 REM Change an active ring
1160 LET k=FN f(a$):PRINT "code" AND b$="?";"targ" AND b$="?";"R
     ing=";INK FN i(k);a$
1170 REM Check ring value
1172 IF k<1 OR k>3 THEN 
       PRINT INK 2;FLASH 1'"INVALID RING COMMAND":STOP
1190 RETURN
1300 REM Get Code ring match    
         on Target ring
1330 FOR w=1 TO 44:IF c$=w$(codeRing,w) THEN 
       LET a$=w$(targRing,w):RETURN
1332 NEXT w
1390 PRINT INK 2;FLASH 1'"INVALID CHARACTER '";c$;"'":STOP
1395 RETURN
2040 REM Start of Encode routine
2041 PRINT '"Characters accepted in message:":BRIGHT 1:FOR c=32
      TO 96:PRINT CHR$ c;:NEXT c:PRINT "{|}~":BRIGHT 0:PRINT "pl
     us Ignore/Resume command:"'BRIGHT 1;"?"
2042 INPUT "Message Key (blank to generate)"'k$''"Message to Enc
     ode>";d$:RANDOMIZE :IF k$>"     " THEN 
       GO SUB 4000:GO TO 2059
2044 PRINT "Building message key ..."
2045 FOR k=1 TO 3:LET c=FN n(43):GO SUB 1000:LET k$(k)=w$(k,1):
     NEXT k
2050 FOR k=4 TO 5:LET k$(k)=FN f$(FN n(3)):NEXT k
2052 LET j=FN f(k$(4)):LET k=FN f(k$(5)):GO SUB 3200:LET codeRin
     g=j:LET targRing=k:LET k$(5)=FN f$(targRing)
2059 REM Main encoding loop     
NOTE*Original character is found
     on targRing & then encoded 
     from codeRing.
2060 PRINT '"Encoding ..."':LET e$=""
2100 FOR d=1 TO LEN d$
2110 LET c$=w$(targRing,FN n(44)):IF c$<"?" OR c$="?" THEN 
       GO TO 2300
2120 REM Construct & execute the
         selected ring command
2122 LET b$=c$:PRINT ,
2159 REM Change Code Ring
2160 IF b$="?" THEN 
       LET j=targRing:GO SUB 3100:LET codeRing=k:GO TO 2110
2169 REM Change Target Ring
2170 IF b$="?" THEN 
       LET j=codeRing:GO SUB 3100:LET targRing=k:GO TO 2110
2179 REM Spin clockwise
2180 IF b$="?" THEN 
       LET dir=+1:GO SUB 2900:GO TO 2110
2189 REM Spin anti-clockwise
2190 IF b$="?" THEN 
       LET dir=-1:GO SUB 2900
2290 GO TO 2110
2300 REM Encode next character
2305 LET c$=d$(d):IF c$<" " OR c$>="a" AND c$<="z" OR c$>"~"
      AND c$<>"?" THEN 
       PRINT INK 2;FLASH 1;"INVALID CHARACTER '";c$;"'":STOP
2310 GO SUB 3400:PRINT c$,INK FN i(FN f(a$));a$
2590 NEXT d
2600 PRINT '"Key = ";k$''"Encoded Message ="''e$:INPUT "Test dec
     oding?[YN]";o$:IF o$="Y" THEN 
       LET o$="D":CLS:GO TO 45
2690 STOP
2900 REM Evaluate a spin command
2910 GO SUB 3400:LET k=FN n(3):LET c$=FN f$(k):PRINT "spin ";
     INK FN i(k);c$;:GO SUB 3400:LET c$=STR$ FN n(9):GO SUB 3400
     :PRINT " ";"+" AND b$="?";"-" AND b$="?";c$
2920 LET c=VAL c$*dir:GO SUB 1000:RETURN
3100 REM Change an active ring
3160 GO SUB 3400:LET k=FN n(3):GO SUB 3200:LET c$=FN f$(k):
     GO SUB 3400:LET a$=c$:GO SUB 1100:RETURN
3200 REM Ensure code/targRings  
         are different (j/k may 
         be either ring)
3210 IF j=k THEN 
       LET dir=FN n(2):LET k=k+(1 AND dir=1)-(1 AND dir=2):LET k
       =k+(2 AND k<1)-(2 AND k>3)
3290 RETURN
3300 REM Get Target ring match  
         on Code ring; or copy  
         unchanged if no match.
3330 FOR w=1 TO 44:IF c$=w$(targRing,w) THEN 
       LET a$=w$(codeRing,w):RETURN
3332 NEXT w
3339 LET a$=c$:POKE 23692,255:RETURN
3400 REM Add to encoded string
3410 GO SUB 3300:LET e$=e$+a$:RETURN
4000 REM 
4050 PRINT "Checking message key ..."
4100 FOR k=1 TO 3
4110 FOR w=1 TO 44:IF k$(k)=w$(k,w) THEN 
       LET c=(w-1):GO SUB 1000:GO TO 4190
4120 NEXT w
4130 LET c$=k$(k):GO TO 1390
4190 NEXT k
4200 LET k=FN f(k$(4)):GO SUB 1170:LET codeRing=k
4210 LET k=FN f(k$(5)):GO SUB 1170:LET targRing=k
4290 RETURN
** END OF FILE **
